#!/usr/bin/python3

import os.path
from os.path import *

import json

# définition  de la classe personne
class Personne():                            
  
    def __init__(self,nom,prenom,age):
        self.nom = nom
        self.prenom = prenom
        self.age = age
        
    def presentation(self):                 
        print("Bonjour, je m'appelle "+self.prenom+" "+self.nom+", j'ai "+str(self.age)+ " ans")
        
    def resume(self):
        print(self.prenom+" "+self.nom+", "+str(self.age)+ " ans")

# fonction de sérialisation d'un objet, pour son écriture sur le disque au format json
def serialiseur(obj):                  
    return {"__class__":"Personne",
        "nom":obj.nom,
        "prenom":obj.prenom,
        "age":obj.age}

# fonction de désérialisation d'un objet, pour sa lecture sur le disque au format json
def deserialiseur(objet):                   
    p = Personne(objet["nom"], objet["prenom"], objet["age"])
    return p
  
# fonction de création d'une nouvelle personne par entrée des informations au clavier  
def nouvellePersonne():                         
    nom = input("nom : ")
    prenom = input("prenom : ")
    strage = input("age : ")
    age = int(strage)
    p = Personne(nom, prenom, age)
    return p
  
# debut du programme  
  
if os.path.isfile("personnes.json"):                               
    fichier = open("personnes.json","r")                               
    liste = json.load(fichier, object_hook = deserialiseur)
    fichier.close()
else:
    liste = []
    
action = "r"     # action sans effet pour rentrer dans la boucle 
while action != "q":    
    action = input("Que voulez-vous faire (a : ajouter une personne, v : voir les personnes, q : quitter)")
    if action == "a":
        p = nouvellePersonne()
        liste.append(p)
    if action == "v":
        for p in liste:
            p.resume()
            
# écriture des informations sur le disque avant de quitter
fichier = open("personnes.json","w")  
json.dump(liste, fichier, default = serialiseur, indent = 2)
fichier.close()
            

        